Package com.sas.metadata.remote

# Interface TableCollection

All Superinterfaces:
  `Classifier`, `CMetadata`, `DataTable`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface TableCollection extends DataTable
A classifier that defines a set of tables that all share the same characteristics but that should be treated as one classifer for display purposes. It is often not known until the table definition is used how many physical representations will exist for a given definition.

Attributes of TableCollection are:

Associations of TableCollection are:

- `CollectionLocations`
- `Tables`

## Usage

To create an instance of this TableCollection, use the `factory` create methods.
Example: create a TableCollection with name "TableCollection_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     TableCollection myObject = (TableCollection) factory.createComplexMetadataObject(objectStore, "TableCollection_Object", MetadataObjects.TABLECOLLECTION, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_COLLECTIONLOCATIONS_NAME`
  Constant used for the name of the CollectionLocations association.
  `static final String`
  `ASSOCIATION_TABLES_NAME`
  Constant used for the name of the Tables association.

  ### Fields inherited from interface com.sas.metadata.remote.Classifier

  `ASSOCIATION_SOURCECLASSIFIERMAPS_NAME, ASSOCIATION_TARGETCLASSIFIERMAPS_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.DataTable

  `ASSOCIATION_COLUMNHIERARCHIES_NAME, ASSOCIATION_COLUMNS_NAME, ASSOCIATION_FOREIGNKEYS_NAME, ASSOCIATION_ROLES_NAME, ASSOCIATION_TABLECOLLECTIONS_NAME, ASSOCIATION_TABLEPACKAGE_NAME, ASSOCIATION_UNIQUEKEYS_NAME, ATTRIBUTE_NUMROWS_NAME, ATTRIBUTE_TABLENAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AssociationList`
  `getCollectionLocations()`
  Gets the AssociationList of `CollectionLocations`
  `AssociationList`
  `getCollectionLocations(boolean fGoToServer)`
  Gets the Associationlist of `CollectionLocations`
  `AssociationList`
  `getTables()`
  Gets the AssociationList of `Tables`
  `AssociationList`
  `getTables(boolean fGoToServer)`
  Gets the Associationlist of `Tables`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `CollectionLocations`
  `Tables`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setCollectionLocations(AssociationList list)`
  Sets the `CollectionLocations` list to be `list`.
  `void`
  `setCollectionLocations(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setTables(AssociationList list)`
  Sets the `Tables` list to be `list`.
  `void`
  `setTables(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList

  ### Methods inherited from interface com.sas.metadata.remote.Classifier

  `getSourceClassifierMaps, getSourceClassifierMaps, getTargetClassifierMaps, getTargetClassifierMaps, setSourceClassifierMaps, setSourceClassifierMaps, setTargetClassifierMaps, setTargetClassifierMaps`

  ### Methods inherited from interface com.sas.metadata.remote.DataTable

  `getColumnHierarchies, getColumnHierarchies, getColumns, getColumns, getForeignKeys, getForeignKeys, getNumRows, getNumRowsState, getRoles, getRoles, getTableCollections, getTableCollections, getTableName, getTableNameMaxLength, getTableNameState, getTablePackage, getTablePackages, getTablePackages, getUniqueKeys, getUniqueKeys, setColumnHierarchies, setColumnHierarchies, setColumns, setColumns, setForeignKeys, setForeignKeys, setNumRows, setNumRows, setNumRows, setNumRows, setNumRowsState, setRoles, setRoles, setTableCollections, setTableCollections, setTableName, setTableName, setTableNameState, setTablePackage, setTablePackages, setTablePackages, setUniqueKeys, setUniqueKeys`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ASSOCIATION_COLLECTIONLOCATIONS_NAME

    static final String ASSOCIATION_COLLECTIONLOCATIONS_NAME
    Constant used for the name of the CollectionLocations association.

    CollectionLocations: The location where the actual tables that make up this collection are located.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_TABLES_NAME

    static final String ASSOCIATION_TABLES_NAME
    Constant used for the name of the Tables association.

    Tables: The tables that are part of this table collection.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `Classifier`
    Specified by:
      `initializeRequiredObjects` in interface `DataTable`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `CollectionLocations`
    `Tables`
    Specified by:
      `initializePredObjects` in interface `Classifier`
    Specified by:
      `initializePredObjects` in interface `DataTable`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCollectionLocations

    AssociationList getCollectionLocations() throws RemoteException, MdException
    Gets the AssociationList of `CollectionLocations`
    Returns:
      Returns the AssociationList of `CollectionLocations` which can be of type:
      DeployedDataPackage
      OLAPSchema
      DatabaseCatalog
      SASCatalog
      RelationalSchema
      DatabaseSchema
      DataSourceName
      SASLibrary
      SecuredLibrary
      ContentLocation
      Text
      TextStore
      SASCatalogEntry
      File
      ArchiveFile
      ArchiveEntry
      Document
      Directory
      AnalyticContext
      Device
      Stream
      Memory
      Connection
      SASClientConnection
      OpenClientConnection
      TCPIPConnection
      COMConnection
      Email
      SASFileRef
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getTables

    AssociationList getTables() throws RemoteException, MdException
    Gets the AssociationList of `Tables`
    Returns:
      Returns the AssociationList of `Tables` which can be of type:
      DataTable
      ExternalTable
      RelationalTable
      PhysicalTable
      WorkTable
      SecuredTable
      QueryTable
      JoinTable
      TableCollection
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCollectionLocations

    AssociationList getCollectionLocations(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `CollectionLocations`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `CollectionLocations` which can be of type:
      DeployedDataPackage
      OLAPSchema
      DatabaseCatalog
      SASCatalog
      RelationalSchema
      DatabaseSchema
      DataSourceName
      SASLibrary
      SecuredLibrary
      ContentLocation
      Text
      TextStore
      SASCatalogEntry
      File
      ArchiveFile
      ArchiveEntry
      Document
      Directory
      AnalyticContext
      Device
      Stream
      Memory
      Connection
      SASClientConnection
      OpenClientConnection
      TCPIPConnection
      COMConnection
      Email
      SASFileRef
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getTables

    AssociationList getTables(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Tables`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Tables` which can be of type:
      DataTable
      ExternalTable
      RelationalTable
      PhysicalTable
      WorkTable
      SecuredTable
      QueryTable
      JoinTable
      TableCollection
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setCollectionLocations

    void setCollectionLocations(AssociationList list) throws RemoteException
    Sets the `CollectionLocations` list to be `list`. Objects of which can be of type:
    DeployedDataPackage
    OLAPSchema
    DatabaseCatalog
    SASCatalog
    RelationalSchema
    DatabaseSchema
    DataSourceName
    SASLibrary
    SecuredLibrary
    ContentLocation
    Text
    TextStore
    SASCatalogEntry
    File
    ArchiveFile
    ArchiveEntry
    Document
    Directory
    AnalyticContext
    Device
    Stream
    Memory
    Connection
    SASClientConnection
    OpenClientConnection
    TCPIPConnection
    COMConnection
    Email
    SASFileRef
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCollectionLocations

    void setCollectionLocations(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTables

    void setTables(AssociationList list) throws RemoteException
    Sets the `Tables` list to be `list`. Objects of which can be of type:
    DataTable
    ExternalTable
    RelationalTable
    PhysicalTable
    WorkTable
    SecuredTable
    QueryTable
    JoinTable
    TableCollection
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTables

    void setTables(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.